var itemEndless = [
  {
    name: "Endless Type I",
    desc: "Endless page with top bar that about to toggle its visibility.<br />\
      Pages will joint the preceding only with their contents.",
    href: "./endless/post.php"
  },
  {
    name: "Endless Type II",
    desc: "Endless page with top bar that about to toggle its visibility.<br />\
      Pages will joint the preceing with their contents and blog's header (i.e. blog logo and menus customized by blogger).",
    href: "./endless/post2.php"
  },
  {
    name: "Endless Type III (Recommended Version)",
    desc: "Endless page with top bar that fixed and always shows current page information.<br />\
      Displayed information is about to mutated by current page's metadata (i.e. blog logo, entry title and social network reputation numbers).<br />\
      Page title information would disappear if it's in small-size screen (e.g. mobile devices or narrow-end tablet).",
    href: "./endless/post-fixed-topbar.php"
  }
];

var itemMongoDB = [
  {
    name: "Tutorials",
    desc: "https://blog.codecentric.de/en/2012/12/mongodb-tutorial/",
    href: "https://blog.codecentric.de/en/2012/12/mongodb-tutorial/"
  },
  {
    name: "Booklet",
    desc: "https://s3.amazonaws.com/info-mongodb-com/mongodb_qrc_booklet.pdf",
    href: "https://s3.amazonaws.com/info-mongodb-com/mongodb_qrc_booklet.pdf"
  },
  {
    name: "Cheat Sheet",
    desc: "Note: the sheet is made since 2012, please be careful when consider to use this.",
    href: "https://blog.codecentric.de/files/2012/12/MongoDB-CheatSheet-v1_0.pdf"
  }
];

var itemPhalcon = [
  {
    name: "Documentation",
    desc: "https://docs.phalconphp.com/en/latest/",
    href: "https://docs.phalconphp.com/en/latest/"
  },
  {
    name: "Cheat Sheet",
    desc: "http://phalcon.io/cheat-sheet/",
    href: "http://phalcon.io/cheat-sheet/"
  },
  {
    name: "Phalcon Tips",
    desc: "http://phalcontip.com/",
    href: "http://phalcontip.com/"
  }
];


var itemPortal = [
  {
    id  : "link-compress",
    name: "Compress",
    desc: "Comparing quality of compressed image.",
    href: "./compress"
  },
  {
    id  : "link-endless",
    name: "Endless Blog Post",
    desc: "Endless scrolling post page preview, with top bar that demands users to share current content.<br />\
      Comes in three variants:",
    subs: itemEndless
  },
  {
    id  : "link-mongodb",
    name: "MongoDB",
    desc: "Some useful references to use with MongoDB development.",
    subs: itemMongoDB
  },
  {
    id  : "link-phalcon",
    name: "PhalconPHP",
    desc: "Some useful references to read with Phalcon PHP development.",
    subs: itemPhalcon
  }
];

var PortalItem = React.createClass({
  render: function(){
    var item;
    if (this.props.subs) {
      item = (
        <li className="media" id={this.props.id}>
          <div className="media-left">
            <img src="" alt="" className="media-object placeholders" />
          </div>
          <div className="media-body">
            <h4 className="media-heading">{this.props.name}</h4>
            <p dangerouslySetInnerHTML={{__html: this.props.desc}} />
            <PortalItemList role="sub" data={this.props.subs} />
          </div>
        </li>
      );
    } else { // has href instead
      item = (
        <li className="media link" data-href={this.props.href} >
          <div className="media-left">
            <img src="" alt="" className="media-object placeholders" />
          </div>
          <div className="media-body">
            <h4 className="media-heading">{this.props.name}</h4>
            <p dangerouslySetInnerHTML={{__html: this.props.desc}} />
          </div>
        </li>
      );
    }
    return item;
  }
});

var PortalItemList = React.createClass({
  render: function(){
    var role = (this.props.role == "sub") ? "media-list sub" : "media-list";
    var items = this.props.data.map(function (item) {
      var itemize;
      if (item.subs) {
        itemize = <PortalItem name={item.name} desc={item.desc} subs={item.subs} />;
      } else {
        itemize = <PortalItem name={item.name} desc={item.desc} href={item.href} />;
      }
      return itemize;
    });
    return (
      <ul className={role}>
        {items}
      </ul>
    );
  }
});

// portal app module
var PortalApp = React.createClass({
  componentDidMount: function () {
    // enable link object
    $(function(){
      $('.link').click(function(e){
        e.preventDefault();
        target = $(this).data('href');
        window.open(target);
      });
    });
  },
  render: function(){
    return(
      <div className="row">
        <div className="col-xs-8 col-xs-offset-2">
          <h2 className="well well-lg text-center text-uppercase">{this.props.title}</h2>
          <PortalItemList data={this.props.data} />
        </div>
      </div>
    );
  }
});

// render
React.render(
  <PortalApp title="Nut @ Notegang Portal" data={itemPortal} />,
  document.getElementById('container')
);